<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Parent Tree Nodes</TITLE>
<link href="suif1_28.html" rel=Next>
<link href="suif1_26.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_26.html">previous</A>, <A HREF="suif1_28.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC27" HREF="suif1_toc.html#TOC27">Parent Tree Nodes</A></H3>

<P>
<A NAME="IDX150"></A>
Each instruction automatically records the <CODE>tree_instr</CODE> node to
which it is attached.  The <CODE>parent</CODE> method retrieves this pointer.
In an expression tree, all of the instructions share the same parent
<CODE>tree_instr</CODE> node, so an instruction may not be directly connected
to its parent node.

</P>
<P>
<A NAME="IDX151"></A>
The <CODE>owner</CODE> method is identical to the <CODE>parent</CODE> method except
for instructions that are used as operands of <CODE>tree_for</CODE> nodes.
Those operands are actually attached to dummy copy instructions on lists
attached to the <CODE>tree_for</CODE> nodes (see section <A HREF="suif1_17.html#SEC17">For Nodes</A>), but many
users will want to treat them as if they are directly attached to the
<CODE>tree_for</CODE> nodes.  Thus, for an instruction in a <CODE>tree_for</CODE>
operand, the <CODE>owner</CODE> method will return a pointer to the
<CODE>tree_for</CODE> node instead of returning the actual parent
<CODE>tree_instr</CODE>.  This only works if the <CODE>tree_for</CODE> operand list
contains a single expression (not a flat list); otherwise, the actual
<CODE>tree_instr</CODE> parent is returned.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_26.html">previous</A>, <A HREF="suif1_28.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
